=== debian/changelog ===
tasmanian (8.1-5) unstable; urgency=medium

  * Rebuild against gfortran 15
  * Drop “Rules-Requires-Root: no”, which is now the default
  * Bump S-V to 4.7.2
  * d/watch: upgrade to format version 5

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 09 Sep 2025 08:03:50 +0200

tasmanian (8.1-4) unstable; urgency=medium

  * Disable autopkgtests that segfault on riscv64
  * Bump S-V to 4.7.1

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 25 Feb 2025 12:22:52 +0100

tasmanian (8.1-3) unstable; urgency=medium

  * Avoid dh_missing error about tasmanian.mod on arch:all builds
    (Closes: #1095755)

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Feb 2025 21:14:34 +0100

tasmanian (8.1-2) unstable; urgency=medium

  * testsuite-i386.patch: new patch, fixes FTBFS on i386

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Feb 2025 17:06:11 +0100

tasmanian (8.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1087848)

 -- Sébastien Villemot <sebastien@debian.org>  Thu, 26 Dec 2024 15:06:53 +0100
