=== debian/control ===
Source: tasmanian
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-fortran-mod,
               dh-sequence-python3,
               cmake,
               libblas-dev,
               liblapack-dev,
               python3-numpy
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/science-team/tasmanian
Vcs-Git: https://salsa.debian.org/science-team/tasmanian.git
Homepage: https://github.com/ORNL/TASMANIAN

Package: tasgrid
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: command-line interface to the Tasmanian sparse grids library
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package contains an executable that provides a command-line interface to
 the Tasmanian Sparse Grids module. It provides the ability to create and
 manipulate sparse grids, save and load them into files and optionally
 interface with another program via text files.

Package: libtasmaniansparsegrid8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian module for sparse grids
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a shared library that implements a variety of sparse
 grids, i.e. a family of algorithms for constructing multidimensional
 quadrature and interpolation rules using multiple tensor products of one
 dimensional rules with varying degree of precision.
 .
 The Tasmanian Sparse Grids Module implements a variety of grids that fall into
 five major categories: global grids, sequence grids, local polynomial grids,
 wavelet grids and fourier grids.

Package: libtasmaniandream8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian module for drawing samples from an arbitrary probability distribution
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a shared library that implements the DiffeRential
 Evolution Adaptive Metropolis (DREAM), which is a method to draw samples from
 an arbitrary probability distribution defined by an arbitrary non-negative
 function. The DREAM approach is similar to the classical Markov Chain Monte
 Carlo, but it evolves a large number of chains simultaneously which leads to
 better parallelization and (potentially) faster convergence. In addition,
 multiple chains allow for better exploration of the probability domain, which
 is often advantageous when working with multi-modal distributions.
 .
 One of the main applications of DREAM is in the field of Bayesian inference,
 where samples are drawn from a posterior distribution comprised from a
 data-informed likelihood and an arbitrary model. The DREAM module of Tasmanian
 can use Tasmanian Sparse Grids approximation to either the model or the
 likelihood.

Package: libtasmanianfortran8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian sparse grids wrappers for Fortran 2003
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a SWIG wrapper around the Tasmanian C++ module for
 sparse grids, making it easy to call it from Fortran 2003.

Package: libtasmaniancaddons8
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Tasmanian add-ons module
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package contains a shared library that provides various additional
 functionalities not included in the core Tasmanian modules.

Package: libtasmanian-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${fortran:Depends},
         libtasmaniansparsegrid8 (= ${binary:Version}),
         libtasmaniandream8 (= ${binary:Version}),
         libtasmanianfortran8 (= ${binary:Version}),
         libtasmaniancaddons8 (= ${binary:Version})
Description: Tasmanian development files
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides all the necessary development files to use the Tasmanian
 modules either from C++, C or Fortran 2003.

Package: octave-tasmanian
Architecture: all
Depends: ${misc:Depends},
         tasgrid
Recommends: octave
Description: Octave interface to the Tasmanian sparse grids module
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a GNU Octave interface to the Tasmanian sparse grids
 module. This interface can also be used from MATLAB.

Package: python3-tasmanian
Architecture: all
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-numpy,
         libtasmanian-dev
Description: Python interface to the Tasmanian sparse grids and DREAM modules
 The Toolkit for Adaptive Stochastic Modeling and Non-Intrusive ApproximatioN
 (Tasmanian) is a collection of robust libraries for high dimensional
 integration and interpolation as well as parameter calibration.
 .
 This package provides a Python interface to the Tasmanian sparse grids and
 DREAM modules.
