=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_INSTALL_RPATH=TRUE \
		-DTasmanian_ENABLE_BLAS=ON \
		-DBLA_VENDOR=Generic -DBLA_PREFER_PKGCONFIG=TRUE \
		-DTasmanian_ENABLE_OPENMP=ON \
		-DTasmanian_TESTS_OMP_NUM_THREADS=4 \
		-DTasmanian_MATLAB_WORK_FOLDER=/tmp \
		-DTasmanian_ENABLE_FORTRAN=ON \
		-DTasmanian_ENABLE_PYTHON=ON

execute_before_dh_install-arch:
	# Do not leave a .mod in /usr/include (it is arch- and compiler-dependent)
	# dh_fortran_mod will put it in the right place (see libtasmanian-dev.fortran-mod)
	# This rule is made arch-dependent because otherwise arch:all builds fail at dh_missing (see #1095755)
	mv debian/tmp/usr/include/*.mod debian/tmp/
